Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 18220)
@@ -30,16 +30,16 @@
   [Item("TypeCoherentExpressionGrammar", "Represents a grammar for functional expressions in which special syntactic constraints are enforced so that boolean and real-valued expressions are not mixed.")]
   public class TypeCoherentExpressionGrammar : DataAnalysisGrammar, ISymbolicDataAnalysisGrammar {
-    private const string ArithmeticFunctionsName = "Arithmetic Functions";
-    private const string TrigonometricFunctionsName = "Trigonometric Functions";
-    private const string ExponentialFunctionsName = "Exponential and Logarithmic Functions";
-    private const string RealValuedSymbolsName = "Real Valued Symbols";
-    private const string TerminalsName = "Terminals";
-    private const string PowerFunctionsName = "Power Functions";
-    private const string ConditionsName = "Conditions";
-    private const string ComparisonsName = "Comparisons";
-    private const string BooleanOperatorsName = "Boolean Operators";
-    private const string ConditionalSymbolsName = "ConditionalSymbols";
-    private const string SpecialFunctionsName = "Special Functions";
-    private const string TimeSeriesSymbolsName = "Time Series Symbols";
+    public const string ArithmeticFunctionsName = "Arithmetic Functions";
+    public const string TrigonometricFunctionsName = "Trigonometric Functions";
+    public const string ExponentialFunctionsName = "Exponential and Logarithmic Functions";
+    public const string RealValuedSymbolsName = "Real Valued Symbols";
+    public const string TerminalsName = "Terminals";
+    public const string PowerFunctionsName = "Power Functions";
+    public const string ConditionsName = "Conditions";
+    public const string ComparisonsName = "Comparisons";
+    public const string BooleanOperatorsName = "Boolean Operators";
+    public const string ConditionalSymbolsName = "ConditionalSymbols";
+    public const string SpecialFunctionsName = "Special Functions";
+    public const string TimeSeriesSymbolsName = "Time Series Symbols";
 
     [StorableConstructor]
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 18220)
@@ -188,5 +188,8 @@
     <Compile Include="Interpreter\SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs" />
     <Compile Include="IntervalUtil.cs" />
+    <Compile Include="LinearScaling.cs" />
     <Compile Include="Selectors\DiversitySelector.cs" />
+    <Compile Include="StructureTemplate\StructureTemplate.cs" />
+    <Compile Include="StructureTemplate\SubFunction.cs" />
     <Compile Include="SymbolicDataAnalysisExpressionTreeAverageSimilarityCalculator.cs" />
     <Compile Include="SymbolicDataAnalysisExpressionTreeSimplificationOperator.cs" />
@@ -256,4 +259,6 @@
     <Compile Include="Symbols\Constant.cs" />
     <Compile Include="Symbols\ConstantTreeNode.cs" />
+    <Compile Include="Symbols\SubFunctionSymbol.cs" />
+    <Compile Include="Symbols\SubFunctionTreeNode.cs" />
     <Compile Include="Symbols\VariableBase.cs" />
     <Compile Include="Symbols\VariableTreeNodeBase.cs" />
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Importer/InfixExpressionParser.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Importer/InfixExpressionParser.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Importer/InfixExpressionParser.cs	(revision 18220)
@@ -82,4 +82,5 @@
     internal static readonly BidirectionalLookup<string, ISymbol>
       knownSymbols = new BidirectionalLookup<string, ISymbol>(StringComparer.InvariantCulture, new SymbolComparer());
+    internal static readonly SubFunctionSymbol subFunctionSymbol = new SubFunctionSymbol();
 
     private Number number = new Number();
@@ -328,7 +329,8 @@
 
     private ISymbol GetSymbol(string tok) {
-      var symb = knownSymbols.GetByFirst(tok).FirstOrDefault();
-      if (symb == null) throw new ArgumentException(string.Format("Unknown token {0} found.", tok));
-      return symb;
+      if (knownSymbols.ContainsFirst(tok))
+        return knownSymbols.GetByFirst(tok).FirstOrDefault();
+      else
+        return subFunctionSymbol;
     }
 
@@ -581,4 +583,14 @@
       if (funcNode.Symbol is LaggedVariable) {
         ParseLaggedVariable(tokens, funcNode);
+      } else if (funcNode.Symbol is SubFunctionSymbol) { // SubFunction
+        var subFunction = funcNode as SubFunctionTreeNode;
+        subFunction.Name = idTok.strVal;
+        // input arguments
+        var args = ParseArgList(tokens);
+        IList<string> arguments = new List<string>();
+        foreach (var arg in args)
+          if (arg is VariableTreeNode varTreeNode)
+            arguments.Add(varTreeNode.VariableName);
+        subFunction.Arguments = arguments;
       } else {
         // functions
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalArithBoundsEstimator.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalArithBoundsEstimator.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalArithBoundsEstimator.cs	(revision 18220)
@@ -248,4 +248,8 @@
 
             break;
+          }
+        case OpCodes.SubFunction: {
+            result = Evaluate(instructions, ref instructionCounter, nodeIntervals, variableIntervals);
+          break;
           }
         default:
@@ -344,5 +348,6 @@
           !(n.Symbol is Power) &&
           !(n.Symbol is Absolute) &&
-          !(n.Symbol is AnalyticQuotient)
+          !(n.Symbol is AnalyticQuotient) &&
+          !(n.Symbol is SubFunctionSymbol)
         select n).Any();
       return !containsUnknownSymbols;
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/OpCodes.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/OpCodes.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/OpCodes.cs	(revision 18220)
@@ -22,5 +22,4 @@
 using System;
 using System.Collections.Generic;
-using System.Linq;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 
@@ -79,4 +78,5 @@
     CubeRoot = 51,
     Tanh = 52,
+    SubFunction = 53,
     Constant = 54
   };
@@ -84,11 +84,11 @@
     // constants for API compatibility only
     public const byte Add = (byte)OpCode.Add;
-    public const byte Sub =(byte)OpCode.Sub;
-    public const byte Mul =(byte)OpCode.Mul;
-    public const byte Div =(byte)OpCode.Div;
-    public const byte Sin =(byte)OpCode.Sin;
-    public const byte Cos =(byte)OpCode.Cos;
-    public const byte Tan =(byte)OpCode.Tan;
-    public const byte Log =(byte)OpCode.Log;
+    public const byte Sub = (byte)OpCode.Sub;
+    public const byte Mul = (byte)OpCode.Mul;
+    public const byte Div = (byte)OpCode.Div;
+    public const byte Sin = (byte)OpCode.Sin;
+    public const byte Cos = (byte)OpCode.Cos;
+    public const byte Tan = (byte)OpCode.Tan;
+    public const byte Log = (byte)OpCode.Log;
     public const byte Exp = (byte)OpCode.Exp;
     public const byte IfThenElse = (byte)OpCode.IfThenElse;
@@ -103,5 +103,5 @@
     public const byte LagVariable = (byte)OpCode.LagVariable;
     public const byte Number = (byte)OpCode.Number;
-    public const byte Constant = (byte) OpCode.Constant;
+    public const byte Constant = (byte)OpCode.Constant;
     public const byte Arg = (byte)OpCode.Arg;
     public const byte Power = (byte)OpCode.Power;
@@ -136,8 +136,8 @@
     public const byte CubeRoot = (byte)OpCode.CubeRoot;
     public const byte Tanh = (byte)OpCode.Tanh;
-
+    public const byte SubFunction = (byte)OpCode.SubFunction;
 
     private static Dictionary<Type, byte> symbolToOpcode = new Dictionary<Type, byte>() {
-       { typeof(Addition), OpCodes.Add },
+      { typeof(Addition), OpCodes.Add },
       { typeof(Subtraction), OpCodes.Sub },
       { typeof(Multiplication), OpCodes.Mul },
@@ -192,5 +192,6 @@
       { typeof(AnalyticQuotient), OpCodes.AnalyticQuotient },
       { typeof(Cube), OpCodes.Cube },
-      { typeof(CubeRoot), OpCodes.CubeRoot }
+      { typeof(CubeRoot), OpCodes.CubeRoot },
+      { typeof(SubFunctionSymbol), OpCodes.SubFunction }
     };
 
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionCompiledTreeInterpreter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionCompiledTreeInterpreter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionCompiledTreeInterpreter.cs	(revision 18220)
@@ -662,4 +662,7 @@
               );
           }
+        case OpCodes.SubFunction: {
+          return MakeExpr(node.GetSubtree(0), variableIndices, row, columns);
+        }
         default:
           throw new NotSupportedException("Unsupported symbol: " + node.Symbol);
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeBatchInterpreter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeBatchInterpreter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeBatchInterpreter.cs	(revision 18220)
@@ -182,8 +182,10 @@
               break;
             }
+
           case OpCodes.Tanh: {
               Tanh(instr.buf, code[c].buf);
               break;
             }
+
           case OpCodes.Absolute: {
               Absolute(instr.buf, code[c].buf);
@@ -194,4 +196,9 @@
               Load(instr.buf, code[c].buf);
               AnalyticQuotient(instr.buf, code[c + 1].buf);
+              break;
+            }
+
+          case OpCodes.SubFunction: {
+              Load(instr.buf, code[c].buf);
               break;
             }
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeILEmittingInterpreter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeILEmittingInterpreter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeILEmittingInterpreter.cs	(revision 18220)
@@ -724,4 +724,8 @@
                                             " is not supported by the SymbolicDataAnalysisTreeILEmittingInterpreter");
           }
+        case OpCodes.SubFunction: {
+          CompileInstructions(il, state, ds);
+          return;
+        }
         default:
           throw new NotSupportedException("Interpretation of symbol " + currentInstr.dynamicNode.Symbol.Name +
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs	(revision 18220)
@@ -529,4 +529,7 @@
             }
           }
+        case OpCodes.SubFunction: {
+            return Evaluate(dataset, ref row, state);
+          }
         default:
           throw new NotSupportedException();
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs	(revision 18220)
@@ -388,4 +388,6 @@
           state.Reset();
           instr.value = interpreter.Evaluate(dataset, ref row, state);
+        } else if (instr.opCode == OpCodes.SubFunction) {
+          instr.value = code[instr.childIndex].value;
         } else {
           var errorText = string.Format("The {0} symbol is not supported by the linear interpreter. To support this symbol, please use the SymbolicDataAnalysisExpressionTreeInterpreter.", instr.dynamicNode.Symbol.Name);
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs	(revision 18220)
@@ -122,5 +122,6 @@
       (byte)OpCode.Cube,
       (byte)OpCode.Absolute,
-      (byte)OpCode.AnalyticQuotient
+      (byte)OpCode.AnalyticQuotient,
+      (byte)OpCode.SubFunction
     };
 
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/LinearScaling.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/LinearScaling.cs	(revision 18220)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/LinearScaling.cs	(revision 18220)
@@ -0,0 +1,92 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  public static class LinearScaling {
+
+    public static ISymbolicExpressionTree AddLinearScalingTerms(ISymbolicExpressionTree tree, double offset = 0.0, double scale = 1.0) {
+      var startNode = tree.Root.Subtrees.First();
+      var template = startNode.Subtrees.First();
+
+      var addNode = new Addition().CreateTreeNode();
+      var mulNode = new Multiplication().CreateTreeNode();
+      var offsetNode = new NumberTreeNode(offset);
+      var scaleNode = new NumberTreeNode(scale);
+
+      addNode.AddSubtree(offsetNode);
+      addNode.AddSubtree(mulNode);
+      mulNode.AddSubtree(scaleNode);
+
+      startNode.RemoveSubtree(0);
+      startNode.AddSubtree(addNode);
+      mulNode.AddSubtree(template);
+      return tree;
+    }
+
+    public static void RemoveLinearScalingTerms(ISymbolicExpressionTree tree) {
+      var startNode = tree.Root.GetSubtree(0);
+      ExtractScalingTerms(tree, out _, out NumberTreeNode scaleNode);
+
+      var evaluationNode = scaleNode.Parent.GetSubtree(1); //move up to multiplication and take second child
+      startNode.RemoveSubtree(0);
+      startNode.AddSubtree(evaluationNode);
+    }
+
+    public static void ExtractScalingTerms(ISymbolicExpressionTree tree,
+      out NumberTreeNode offset, out NumberTreeNode scale) {
+      var startNode = tree.Root.Subtrees.First();
+
+      //check for scaling terms
+      var addNode = startNode.GetSubtree(0);
+      var offsetNode = addNode.GetSubtree(0);
+      var mulNode = addNode.GetSubtree(1);
+      var scaleNode = mulNode.GetSubtree(0);
+
+
+      var error = false;
+      if (!(addNode.Symbol is Addition)) error = true;
+      if (!(mulNode.Symbol is Multiplication)) error = true;
+      if (!(offsetNode is NumberTreeNode)) error = true;
+      if (!(scaleNode is NumberTreeNode)) error = true;
+      if (error) throw new ArgumentException("Scaling terms cannot be found.");
+
+      offset = (NumberTreeNode)offsetNode;
+      scale = (NumberTreeNode)scaleNode;
+    }
+
+    public static void AdjustLinearScalingParams(IRegressionProblemData problemData, ISymbolicExpressionTree tree, ISymbolicDataAnalysisExpressionTreeInterpreter interpreter) {
+      ExtractScalingTerms(tree, out NumberTreeNode offsetNode, out NumberTreeNode scaleNode);
+
+      var estimatedValues = interpreter.GetSymbolicExpressionTreeValues(tree, problemData.Dataset, problemData.TrainingIndices);
+      var targetValues = problemData.TargetVariableTrainingValues;
+
+      OnlineLinearScalingParameterCalculator.Calculate(estimatedValues, targetValues, out double a, out double b, out OnlineCalculatorError error);
+      if (error == OnlineCalculatorError.None) {
+        offsetNode.Value = a + b * offsetNode.Value;
+        scaleNode.Value = b * scaleNode.Value;
+      }
+    }
+  }
+}
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/StructureTemplate/StructureTemplate.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/StructureTemplate/StructureTemplate.cs	(revision 18220)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/StructureTemplate/StructureTemplate.cs	(revision 18220)
@@ -0,0 +1,190 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  [StorableType("E3C038DB-C6AA-457D-9F65-AF16C44CCE22")]
+  [Item("StructureTemplate", "Structure Template")]
+  public class StructureTemplate : Item {
+
+    #region Properties
+    [Storable]
+    private string template;
+    public string Template {
+      get => template;
+      set {
+        if (value == template) return;
+
+        var parsedTree = Parser.Parse(value);
+        //assignment must be done after successfully parsing the tree
+        template = value;
+
+        if (applyLinearScaling)
+          parsedTree = LinearScaling.AddLinearScalingTerms(parsedTree);
+        Tree = parsedTree;
+        OnChanged();
+      }
+    }
+
+    private ISymbolicExpressionTree _oldTree;
+    [Storable(OldName = "treeWithoutLinearScaling")]
+    private ISymbolicExpressionTree _OldTreeW {
+      set => _oldTree = value;
+    }
+
+    [Storable]
+    private ISymbolicExpressionTree tree;
+    public ISymbolicExpressionTree Tree {
+      get => tree;
+      private set {
+        containsNumericParameters = null;
+
+        var newFunctions = CreateSubFunctions(value);
+        var oldFunctions = subFunctions?.Intersect(newFunctions)
+                           ?? Enumerable.Empty<SubFunction>();
+        // adds new functions and keeps the old ones (if they match)
+        var functionsToAdd = newFunctions.Except(oldFunctions);
+        subFunctions = functionsToAdd.Concat(oldFunctions).ToList();
+        RegisterSubFunctionEventHandlers(functionsToAdd);
+
+        tree = value;
+      }
+    }
+
+    private bool? containsNumericParameters;
+    public bool ContainsNumericParameters {
+      get {
+        if (!containsNumericParameters.HasValue)
+          containsNumericParameters = Tree.IterateNodesPrefix().OfType<NumberTreeNode>().Any();
+
+        return containsNumericParameters.Value;
+      }
+    }
+
+    [Storable]
+    private IList<SubFunction> subFunctions = new List<SubFunction>();
+    public IEnumerable<SubFunction> SubFunctions => subFunctions;
+
+    [Storable]
+    private bool applyLinearScaling;
+    public bool ApplyLinearScaling {
+      get => applyLinearScaling;
+      set {
+        if (value == applyLinearScaling) return;
+
+        applyLinearScaling = value;
+        if (applyLinearScaling) LinearScaling.AddLinearScalingTerms(Tree);
+        else LinearScaling.RemoveLinearScalingTerms(Tree);
+
+        OnChanged();
+      }
+    }
+
+    protected InfixExpressionParser Parser { get; set; } = new InfixExpressionParser();
+    #endregion
+
+    #region Events
+    public event EventHandler Changed;
+
+    private void OnChanged() => Changed?.Invoke(this, EventArgs.Empty);
+    #endregion
+
+    #region Constructors
+    public StructureTemplate() {
+      Reset();
+    }
+
+    [StorableConstructor]
+    protected StructureTemplate(StorableConstructorFlag _) : base(_) { }
+
+    protected StructureTemplate(StructureTemplate original, Cloner cloner) : base(original, cloner) {
+      this.tree = cloner.Clone(original.tree);
+      this.template = original.Template;
+      this.applyLinearScaling = original.ApplyLinearScaling;
+      this.subFunctions = original.subFunctions.Select(cloner.Clone).ToList();
+      RegisterSubFunctionEventHandlers(SubFunctions);
+    }
+
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      if (Tree == null && _oldTree != null) {
+        if (ApplyLinearScaling) _oldTree = LinearScaling.AddLinearScalingTerms(_oldTree);
+        Tree = _oldTree;
+        _oldTree = null;
+      }
+
+      RegisterSubFunctionEventHandlers(SubFunctions);
+    }
+    #endregion
+
+    #region Cloning
+    public override IDeepCloneable Clone(Cloner cloner) =>
+      new StructureTemplate(this, cloner);
+    #endregion
+
+    public void Reset() {
+      subFunctions = new List<SubFunction>();
+      tree = null;
+      containsNumericParameters = null;
+      Template = "f(_)";
+    }
+
+    private static IList<SubFunction> CreateSubFunctions(ISymbolicExpressionTree tree) {
+      var subFunctions = new List<SubFunction>();
+      foreach (var node in tree.IterateNodesPrefix())
+        if (node is SubFunctionTreeNode subFunctionTreeNode) {
+          if (!subFunctionTreeNode.Arguments.Any())
+            throw new ArgumentException($"The sub-function '{subFunctionTreeNode}' requires inputs (e.g. {subFunctionTreeNode.Name}(var1, var2)).");
+
+          var existingSubFunction = subFunctions.Where(x => x.Name == subFunctionTreeNode.Name).FirstOrDefault();
+          if (existingSubFunction != null) {
+            // an existing subFunction must have the same signature
+            if (!existingSubFunction.Arguments.SequenceEqual(subFunctionTreeNode.Arguments))
+              throw new ArgumentException(
+                $"The sub-function '{existingSubFunction.Name}' has (at least two) different signatures " +
+                $"({existingSubFunction.Name}({string.Join(",", existingSubFunction.Arguments)}) <> " +
+                $"{subFunctionTreeNode.Name}({string.Join(",", subFunctionTreeNode.Arguments)})).");
+          } else {
+            var subFunction = new SubFunction() {
+              Name = subFunctionTreeNode.Name,
+              Arguments = subFunctionTreeNode.Arguments
+            };
+            subFunctions.Add(subFunction);
+          }
+        }
+      return subFunctions;
+    }
+
+    private void RegisterSubFunctionEventHandlers(IEnumerable<SubFunction> subFunctions) {
+      foreach (var sf in subFunctions) {
+        sf.Changed += (o, e) => OnChanged();
+      }
+    }
+  }
+}
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/StructureTemplate/SubFunction.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/StructureTemplate/SubFunction.cs	(revision 18220)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/StructureTemplate/SubFunction.cs	(revision 18220)
@@ -0,0 +1,116 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  [StorableType("598B5DCB-95AC-465A-920B-E1E6DACFFA4B")]
+  public class SubFunction : ParameterizedNamedItem {
+    #region Constants
+    private const string GrammarParameterName = "Grammar";
+    private const string MaximumSymbolicExpressionTreeDepthParameterName = "MaximumSymbolicExpressionTreeDepth";
+    private const string MaximumSymbolicExpressionTreeLengthParameterName = "MaximumSymbolicExpressionTreeLength";
+    #endregion
+
+    #region Parameters
+    public IValueParameter<ISymbolicDataAnalysisGrammar> GrammarParameter => (IValueParameter<ISymbolicDataAnalysisGrammar>)Parameters[GrammarParameterName];
+    public IFixedValueParameter<IntValue> MaximumSymbolicExpressionTreeDepthParameter => (IFixedValueParameter<IntValue>)Parameters[MaximumSymbolicExpressionTreeDepthParameterName];
+    public IFixedValueParameter<IntValue> MaximumSymbolicExpressionTreeLengthParameter => (IFixedValueParameter<IntValue>)Parameters[MaximumSymbolicExpressionTreeLengthParameterName];
+    #endregion
+
+    #region Properties
+    public ISymbolicDataAnalysisGrammar Grammar {
+      get => GrammarParameter.Value;
+      set => GrammarParameter.Value = value;
+    }
+
+    public int MaximumSymbolicExpressionTreeDepth {
+      get => MaximumSymbolicExpressionTreeDepthParameter.Value.Value;
+      set => MaximumSymbolicExpressionTreeDepthParameter.Value.Value = value;
+    }
+
+    public int MaximumSymbolicExpressionTreeLength {
+      get => MaximumSymbolicExpressionTreeLengthParameter.Value.Value;
+      set => MaximumSymbolicExpressionTreeLengthParameter.Value.Value = value;
+    }
+
+    [Storable]
+    public IEnumerable<string> Arguments { get; set; }
+    #endregion
+
+    #region Events
+    public event EventHandler Changed;
+    #endregion
+
+    #region Constructors
+    public SubFunction() {
+      var grammar = new TypeCoherentExpressionGrammar();
+      grammar.ConfigureAsDefaultRegressionGrammar();
+      grammar.Symbols.First(s => s.Name == TypeCoherentExpressionGrammar.ExponentialFunctionsName).Enabled = false;
+      Parameters.Add(new ValueParameter<ISymbolicDataAnalysisGrammar>(GrammarParameterName, grammar));
+      Parameters.Add(new FixedValueParameter<IntValue>(MaximumSymbolicExpressionTreeDepthParameterName, new IntValue(8)));
+      Parameters.Add(new FixedValueParameter<IntValue>(MaximumSymbolicExpressionTreeLengthParameterName, new IntValue(20)));
+      RegisterEventHandlers();
+    }
+
+    protected SubFunction(SubFunction original, Cloner cloner) : base(original, cloner) {
+      Arguments = original.Arguments;
+      RegisterEventHandlers();
+    }
+
+    [StorableConstructor]
+    protected SubFunction(StorableConstructorFlag _) : base(_) { }
+    public override IDeepCloneable Clone(Cloner cloner) =>
+      new SubFunction(this, cloner);
+
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterEventHandlers();
+    }
+    #endregion
+
+    #region Event Handling
+    private void RegisterEventHandlers() {
+      GrammarParameter.ValueChanged += (o, e) => {
+        if (Grammar is TypeCoherentExpressionGrammar tceg) tceg.ConfigureAsDefaultRegressionGrammar();
+        OnParameterValueChanged(o, e);
+      };
+      MaximumSymbolicExpressionTreeDepthParameter.Value.ValueChanged += OnParameterValueChanged;
+      MaximumSymbolicExpressionTreeLengthParameter.Value.ValueChanged += OnParameterValueChanged;
+    }
+
+    private void OnParameterValueChanged(object sender, EventArgs e) =>
+      Changed?.Invoke(this, EventArgs.Empty);
+    #endregion
+
+
+    public override string ToString() => $"{Name}({string.Join(",", Arguments)})";
+
+    public override int GetHashCode() => ToString().GetHashCode();
+
+    public override bool Equals(object obj) => (obj is SubFunction other) && other.ToString() == ToString();
+
+    public void SetupVariables(IEnumerable<string> inputVariables) {
+      var allowedInputVariables = new List<string>(inputVariables);
+
+      foreach (var varSym in Grammar.Symbols.OfType<Variable>()) {
+        // set all variables
+        varSym.AllVariableNames = allowedInputVariables;
+
+        // set all allowed variables
+        if (Arguments.Contains("_")) {
+          varSym.VariableNames = allowedInputVariables;
+        } else {
+          varSym.VariableNames = Arguments.ToList();
+        }
+
+        varSym.Enabled = true;
+      }
+    }
+  }
+}
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/SubFunctionSymbol.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/SubFunctionSymbol.cs	(revision 18220)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/SubFunctionSymbol.cs	(revision 18220)
@@ -0,0 +1,25 @@
+﻿using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  [StorableType("C6C2FBEE-8F4B-4FF2-80F5-D566BE55ED69")]
+  [Item("SubFunction", "Symbol that represents a sub function.")]
+  public sealed class SubFunctionSymbol : Symbol {
+    public override int MinimumArity => 0;
+    public override int MaximumArity => 1;
+
+    public SubFunctionSymbol() : base("SubFunction", "Symbol that represents a sub function.") { }
+
+    private SubFunctionSymbol(SubFunctionSymbol original, Cloner cloner) : base(original, cloner) { }
+
+    [StorableConstructor]
+    private SubFunctionSymbol(StorableConstructorFlag _) : base(_) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) =>
+      new SubFunctionSymbol(this, cloner);
+
+    public override ISymbolicExpressionTreeNode CreateTreeNode() => new SubFunctionTreeNode(this);
+  }
+}
